"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _TextField = _interopRequireDefault(require("@material-ui/core/TextField"));

var _reactFormValidatorCore = require("react-form-validator-core");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _get(target, property, receiver) { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(receiver); } return desc.value; }; } return _get(target, property, receiver || target); }

function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var TextValidatorCore =
/*#__PURE__*/
function (_ValidatorComponent) {
  _inherits(TextValidatorCore, _ValidatorComponent);

  function TextValidatorCore() {
    _classCallCheck(this, TextValidatorCore);

    return _possibleConstructorReturn(this, _getPrototypeOf(TextValidatorCore).apply(this, arguments));
  }

  _createClass(TextValidatorCore, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      _get(_getPrototypeOf(TextValidatorCore.prototype), "componentDidMount", this).call(this);

      if (this.props.doInitialValidation) {
        this.validate(this.props.value, true);
      }
    }
  }, {
    key: "onChange",
    value: function onChange(event) {
      if (this.props.onChange) {
        this.props.onChange(event.target.value);
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          error = _this$props.error,
          errorMessages = _this$props.errorMessages,
          validators = _this$props.validators,
          requiredError = _this$props.requiredError,
          helperText = _this$props.helperText,
          validatorListener = _this$props.validatorListener,
          withRequiredValidator = _this$props.withRequiredValidator,
          onChange = _this$props.onChange,
          children = _this$props.children,
          doInitialValidation = _this$props.doInitialValidation,
          rest = _objectWithoutProperties(_this$props, ["error", "errorMessages", "validators", "requiredError", "helperText", "validatorListener", "withRequiredValidator", "onChange", "children", "doInitialValidation"]);

      var isValid = this.state.isValid;
      return _react["default"].createElement(_TextField["default"], _extends({}, rest, {
        onChange: this.onChange.bind(this),
        helperText: !isValid && this.getErrorMessage(),
        error: !isValid || error
      }));
    }
  }]);

  return TextValidatorCore;
}(_reactFormValidatorCore.ValidatorComponent);

TextValidatorCore.propTypes = {
  // ValidatorComponent
  errorMessages: _propTypes["default"].oneOfType([_propTypes["default"].array, _propTypes["default"].string]),
  validators: _propTypes["default"].array,
  value: _propTypes["default"].any,
  validatorListener: _propTypes["default"].func,
  withRequiredValidator: _propTypes["default"].bool,
  // Custom
  doInitialValidation: _propTypes["default"].bool
};
TextValidatorCore.defaultProps = {
  // ValidatorComponent
  errorMessages: 'error',
  validators: [],
  validatorListener: function validatorListener() {},
  // Custom
  doInitialValidation: false
};
var _default = TextValidatorCore;
exports["default"] = _default;